from .resnet_fpn import ResNetFPN_8_2, ResNetFPN_8_4_2


def build_backbone(config):
    if config['backbone_type'] == 'ResNetFPN':
        if config['resolution'] == (8, 2):
            return ResNetFPN_8_2(config['resnetfpn'])
        elif config['resolution'] == (8, 4, 2):
            return ResNetFPN_8_4_2(config['resnetfpn'])
        elif config['resolution'] == (16, 4):
            raise NotImplementedError
    else:
        raise ValueError(f"LOFTR.BACKBONE_TYPE {config['backbone_type']} not supported")